package bin;
import java.util.Scanner;
public class bina {
	public static void main(String[] args) {
		int c=0,c1=0;
		Scanner s = new Scanner(System.in);
		int n = s.nextInt();
		s.nextLine();
		int[] bin = new int[n];
		int S = s.nextInt();
		s.nextLine();
		int Q = s.nextInt();
		s.nextLine();
		int[] L = new int[Q];
		int[] R = new int[Q];
		int[] bin2 = new int[n];
		String bin1=s.nextLine();
		for(int i=0;i<n;i++) {
			bin[i]=bin1.charAt(i)-'0';
		}
		for(int i=0;i<Q;i++) {
			L[i]=s.nextInt();
			R[i]=s.nextInt();
		}
		for(int i=0;i<Q;i++) {
			c1=0;
			c=0;
			for(int j = L[i]-1;j<R[i];j++) {
				if(bin[j]==1)bin[j]=0;
				else if(bin[j]==0)bin[j]=1;
			}
			bin2=bin.clone();
			for(int j=0;j<n;j++)if(bin2[j]==1)c++;
			if(c>n-c&&c>S) {
				for(int k=0;k<n;k++) {
					if(bin2[k]==1) {
						c1+=S;
						for(int p=k;p<n;p++) {
							if(bin2[p]==1)bin2[p]=0;
							else if(bin2[p]==0)bin2[p]=1;
						}
						break;
					}
				}
				for(int k=0;k<n;k++) {
					if(bin2[k]==1)c1++;
				}
			}
			else {
				for(int k=0;k<n;k++) {
					if(bin2[k]==1)c1++;
				}
				
			}
			
			
		System.out.println(c1);
		}
		
	}

}